package com.insomnia.GUI;
/**
 * this Class represents the GUI for Insomnia
 * @zahra_Fatehi
 * @version 0.0
 */

import com.insomnia.parser.RequestData;
import com.insomnia.parser.ResponseData;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.IOException;
import static com.sun.glass.ui.Cursor.setVisible;
import static java.awt.Frame.*;


public class InsomniaGUI {
   private JFrame frame ;
   private RespondPanel response;
   private RequestPanel request;
   private ResponseData data_req = null;


    /**
     * create a insomnia gui
     * @throws IOException
     */
    public InsomniaGUI() throws IOException {
        frame = new JFrame();
        frame.setTitle("Insomnia");
       // frame.setSize(900,600);
        frame.setLocation(200,100);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);

        request = new RequestPanel(this);
        request.createRequestPanel();
        response = new RespondPanel();
        response.createRespondPanel();
        JPanel panelRight = new JPanel(new GridLayout(1 ,2 ));
        panelRight.add(request);
        panelRight.add(response);
        LeftPanel leftPanel = new LeftPanel(this);
        leftPanel.createLeftPanel();

        //menu upper_Items
        JMenuBar upperMenuBar = new JMenuBar();
        JMenu application = new JMenu("Application");
        JMenuItem OptionItem = new JMenuItem("Option");
        OptionItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O , ActionEvent.CTRL_MASK));
        JPanel optionPanel = new JPanel(new GridLayout(3,1));
        JCheckBox followRedirect = new JCheckBox("follow redirect");
        JCheckBox hideInSystemTray = new JCheckBox("hide in system tray");
        String color []={"light theme","dark theme"};
        JComboBox backGroundColor = new JComboBox(color);
        backGroundColor.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String s = (String) backGroundColor.getSelectedItem();//get the selected item

                switch (s) {//check for a match
                    case "light theme":{
                        response.getCookie().setBackground(Color.WHITE);
                        response.getCopyToClipBoard().setBackground(Color.WHITE);
                        response.getHeader_MainPanel().setBackground(Color.WHITE);
                        response.getMainCenterHeader_respond().setBackground(Color.WHITE);
                        response.getMassageBody().setBackground(Color.WHITE);
                        response.getScrollPane_Header_Respond().setBackground(Color.WHITE);
                        response.getTabbedPaneCenterResponse().setBackground(Color.WHITE);
                        response.getTimeline().setBackground(Color.WHITE);
                        response.getRow().setBackground(Color.WHITE);
                        request.getRootPane().setBackground(Color.WHITE);
                        request.getBody().setBackground(Color.WHITE);
                        request.getDocs().setBackground(Color.WHITE);
                        request.getCenterMenu().setBackground(Color.WHITE);
                        request.getCenterUp().setBackground(Color.WHITE);
                        request.getMainCenterHeader().setBackground(Color.WHITE);
                        request.getScrollPane_Header_Request().setBackground(Color.WHITE);
                        request.getTabbedPaneCenterRequest().setBackground(Color.WHITE);
                        leftPanel.getAddRequest().setBackground(Color.WHITE);
                        leftPanel.getMenu().setBackground(Color.WHITE);
                        leftPanel.getScrollRequests().setBackground(Color.WHITE);
                        leftPanel.getRequestList().setBackground(Color.WHITE);
                        leftPanel.getUp_left().setBackground(Color.WHITE);
                        leftPanel.getAddRequest().setBackground(Color.WHITE);
                        break;
                    }
                    case "dark theme":{
                        response.getCookie().setBackground(Color.DARK_GRAY);
                        response.getCopyToClipBoard().setBackground(Color.DARK_GRAY);
                        response.getHeader_MainPanel().setBackground(Color.DARK_GRAY);
                        response.getMainCenterHeader_respond().setBackground(Color.DARK_GRAY);
                        response.getMassageBody().setBackground(Color.DARK_GRAY);
                        response.getScrollPane_Header_Respond().setBackground(Color.DARK_GRAY);
                        response.getTabbedPaneCenterResponse().setBackground(Color.DARK_GRAY);
                        response.getTimeline().setBackground(Color.DARK_GRAY);
                        response.getRow().setBackground(Color.DARK_GRAY);
                        request.getRootPane().setBackground(Color.DARK_GRAY);
                        request.getBody().setBackground(Color.DARK_GRAY);
                        request.getDocs().setBackground(Color.DARK_GRAY);
                        request.getCenterMenu().setBackground(Color.DARK_GRAY);
                        request.getCenterUp().setBackground(Color.DARK_GRAY);
                        request.getMainCenterHeader().setBackground(Color.DARK_GRAY);
                        request.getScrollPane_Header_Request().setBackground(Color.DARK_GRAY);
                        request.getTabbedPaneCenterRequest().setBackground(Color.DARK_GRAY);
                        leftPanel.getAddRequest().setBackground(Color.DARK_GRAY);
                        leftPanel.getMenu().setBackground(Color.DARK_GRAY);
                        leftPanel.getScrollRequests().setBackground(Color.DARK_GRAY);
                        leftPanel.getRequestList().setBackground(Color.DARK_GRAY);
                        leftPanel.getUp_left().setBackground(Color.DARK_GRAY);
                        leftPanel.getAddRequest().setBackground(Color.DARK_GRAY);
                    }
                }
            }
        });
        backGroundColor.setFont(new Font("Arial",20,15 ));
        optionPanel.add(followRedirect);
        optionPanel.add(hideInSystemTray);
        optionPanel.add(backGroundColor);
        JFrame optionFrame= new JFrame("option");
        optionFrame.setPreferredSize(new Dimension(100,100));
        optionPanel.setPreferredSize(new Dimension(100,100));
        optionFrame.add(optionPanel);
        OptionItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                optionFrame.setVisible(true);
            }
        });


        JMenuItem exitItem = new JMenuItem("Exit  ");
        exitItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,ActionEvent.ALT_MASK));
        exitItem.addActionListener(new exitApp(hideInSystemTray));
        application.add(OptionItem);
        application.add(exitItem);
        JMenu edit = new JMenu("Edit");
        edit.setMnemonic('E');
        JMenu view = new JMenu("View");
        view.setMnemonic('V');
        JMenuItem ToggleFullScreen = new JMenuItem("Toggle Full Screen");
        ToggleFullScreen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T , KeyEvent.VK_F));
        ToggleFullScreen.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (frame.getExtendedState() == MAXIMIZED_BOTH){
                    frame.setExtendedState(NORMAL);
                }
                else {
                    frame.setExtendedState(MAXIMIZED_BOTH);
                }
            }
        });
        JMenuItem ToggleSidebar = new JMenuItem("Toggle Sidebar");
        ToggleSidebar.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (leftPanel.isVisible() == true) {
                    leftPanel.setVisible(false);
                }
                else {
                    leftPanel.setVisible(true);
                }
            }
        });
        ToggleSidebar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L ,KeyEvent.VK_S ));
        view.add(ToggleFullScreen);
        view.add(ToggleSidebar);
        JMenu window = new JMenu("Tools");
        window.setMnemonic('W');
        JMenuItem minimize = new JMenuItem("Minimize");
        window.add(minimize);
        JMenu help = new JMenu("Help");
        help.setMnemonic('H');
        JMenuItem  aboutItem = new JMenuItem("About");
        aboutItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A , ActionEvent.CTRL_MASK));
        aboutItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JPanel aboutPanel = new JPanel();
                JTextArea aboutText = new JTextArea();
                aboutText.setLineWrap(true);
                aboutText.setEditable(false);
                aboutText.setText("developer\tzahra seyedFatehi    \nEmail   \ts.fatehi1378@Gmail.com\nstudent number\t9731301");
                aboutPanel.add(aboutText);
                aboutText.setPreferredSize(new Dimension(300,200));
                JFrame frame = new JFrame("About");
                frame.setLocation(100,100);
                frame.setPreferredSize(new Dimension(200,200));
                frame.add(aboutPanel);
                frame.setVisible(true);
            }
        });
        help.add( aboutItem);
        JMenuItem helpItem= new JMenuItem("help");
        helpItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H , ActionEvent.CTRL_MASK));
        helpItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JPanel helpPanel = new JPanel();
                JTextArea helpText = new JTextArea();
                helpText.setLineWrap(true);
                helpPanel.add(helpText);
                frame.setLocation(100,100);
                frame.setPreferredSize(new Dimension(200,200));
                frame.add(helpPanel);
                frame.setVisible(true);
            }
        });
        help.add(helpItem);
        upperMenuBar.add(application);
        upperMenuBar.add(edit);
        upperMenuBar.add(view);
        upperMenuBar.add(window);
        upperMenuBar.add(help);
        upperMenuBar.setFocusable(true);



        JPanel panel = new JPanel(new BorderLayout());
        panel.add(upperMenuBar , BorderLayout.NORTH);
        panel.add(leftPanel , BorderLayout.WEST);
        panel.add(panelRight , BorderLayout.CENTER);

        frame.getContentPane().add(panel);
        frame.setSize(800,400);
    }


    // Exit app
    public class exitApp implements ActionListener
    {
        JCheckBox checkbox ;
        public exitApp(JCheckBox hideInSystemTray){
            checkbox = hideInSystemTray;
        }
        public void actionPerformed(ActionEvent e)
        {
            if (checkbox.isSelected() == true){
                TrayIcon trayIcon;
                SystemTray tray;
                if(SystemTray.isSupported()){
                    System.out.println("system tray supported");
                    tray=SystemTray.getSystemTray();

                    Image image=Toolkit.getDefaultToolkit().getImage("/media/faisal/DukeImg/Duke256.png");
                    ActionListener exitListener=new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            System.out.println("Exiting....");
                            System.exit(0);
                        }
                    };
                    PopupMenu popup=new PopupMenu();
                    MenuItem defaultItem=new MenuItem("Exit");
                    defaultItem.addActionListener(exitListener);
                    popup.add(defaultItem);
                    defaultItem=new MenuItem("Open");
                    defaultItem.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            setVisible(true);
                            frame.setExtendedState(NORMAL);
                        }
                    });
                    popup.add(defaultItem);
                    trayIcon=new TrayIcon(image, "SystemTray Demo", popup);
                    trayIcon.setImageAutoSize(true);
                }else{
                    System.out.println("system tray not supported");
                }
                setVisible(true);
            }
            else
                System.exit(0);
        }
    }


    /**
     * this method is for loading data for sending data and get the response
     * @param d
     */
    public void load(ResponseData d){
        data_req = d;
        response.load(d);
    }

    /**
     * this method checks that is there any request here or not
     */
    public boolean hasRequest(){
        return data_req!=null;
    }

    /**
     * @param r is the request data
     */
    public void loadRequest (RequestData r){
        request.load(r);
    }

    /**
     * @return the frame of app
     */
    public JFrame getFrame() {
        return frame;
    }

    /**
     *set the frame of app
     */
    public void setFrame(JFrame frame) {
        this.frame = frame;
    }

    /**
     * get the response panel
     * @return the response panel
     */
    public RespondPanel getResponse() {
        return response;
    }

    /**
     * set the response panel
     */
    public void setResponse(RespondPanel response) {
        this.response = response;
    }

    /**
     *
     * @return the request panel
     */
    public RequestPanel getRequest() {
        return request;
    }

    /**
     *set the request panel
     */
    public void setRequest(RequestPanel request) {
        this.request = request;
    }

    public ResponseData getData_req() {
        return data_req;
    }
}
