package com.insomnia.GUI;

import com.insomnia.parser.RequestData;
import com.insomnia.parser.ResponseData;
import com.insomnia.parser.Saver;

import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;

public class LeftPanel extends JPanel {
    Border border = BorderFactory.createLineBorder(Color.BLACK,3);
    VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    JButton addRequest = new JButton("Save Request");
    JMenu menu = new JMenu("Insomnia");
    JPanel requestList = new JPanel(vfLayout);
    JScrollPane scrollRequests = new JScrollPane(requestList);
    JPanel up_left = new JPanel(new GridLayout(2,1));

    InsomniaGUI main_class;
    public LeftPanel (InsomniaGUI m){
        main_class = m;
    }

    //left panel (list of requests)
    public void createLeftPanel() {
        menu.setFont(new Font("Arial",20,15 ));
        menu.setBorder(border);
        menu.setPreferredSize(new Dimension(200,60));
        up_left.add(menu);
        up_left.add(addRequest);
        up_left.setBackground(Color.GRAY);
        requestList.setBackground(Color.GRAY);
        addRequest.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {

                if (!main_class.hasRequest()){
                    JOptionPane.showMessageDialog(main_class.getFrame(),"You need to send a request first.","Error",JOptionPane.ERROR_MESSAGE);
                    return;
                }
                JFrame newRequestFrame = new JFrame("request name");
                JLabel label = new JLabel("new request");
                JTextField textField = new JTextField();
                JPanel panel = new JPanel();
                label.setBounds(40,40,40,30);
                textField.setBounds(100, 40, 100,30);
                JButton  create = new JButton("create");
                textField.setPreferredSize(new Dimension(70,50));
                panel.add(label);
                panel.add(textField);
                panel.add(create);
                newRequestFrame.add(panel);
                newRequestFrame.setPreferredSize(new Dimension(200,200));
                newRequestFrame.setVisible(true);
                newRequestFrame.pack();
                create.addMouseListener(new MouseAdapter() {
                    @Override
                    public void mouseClicked(MouseEvent e) {
                        super.mouseClicked(e);
                        String name = textField.getText();
                        newRequestFrame.setVisible(false);

                        //Save Request
                        ResponseData data = main_class.getData_req();
                        data.getRequestData().setName(name);
                        new Saver().saveRequestAndResponse(data);
                        //Add Request to list
                        JButton newRequest = new JButton(name);
                        newRequest.addMouseListener(new MouseRequestClick(name));
                        requestList.add(newRequest);
                        requestList.validate();
                    }
                });
            }
        });

        for(File f : Saver.getRequestFiles()){
            String name = f.getName();
            if (name.endsWith(".insomnia")) {
                name = name.substring(0,name.length()-9);
                JButton newRequest = new JButton(name);
                newRequest.addMouseListener(new MouseRequestClick(name));
                requestList.add(newRequest);
            }
        }
        requestList.validate();

        this.setLayout(new BorderLayout());
        this.setBackground(Color.GRAY);
        this.add(up_left, BorderLayout.NORTH);
        this.add(scrollRequests, BorderLayout.CENTER);
        this.setBackground(Color.LIGHT_GRAY);
    }

    /**
     *
     * @return the addRequest button
     */
    public JButton getAddRequest() {
        return addRequest;
    }

    /**
     *
     * @return the menu
     */
    public JMenu getMenu() {
        return menu;
    }

    public JPanel getRequestList() {
        return requestList;
    }

    public JScrollPane getScrollRequests() {
        return scrollRequests;
    }

    public JPanel getUp_left() {
        return up_left;
    }


    private class MouseRequestClick extends MouseAdapter {
        String name;
        MouseRequestClick(String name){
            this.name =name;
        }
         @Override
        public void mouseClicked(MouseEvent e){
            super.mouseClicked(e);
            ResponseData data = new Saver().readRequestAndResponse(name);
            data.getRequestData().setName("");
            main_class.load(data);
            main_class.loadRequest(data.getRequestData());
        }
    }
}

