/**
 * represents a panel for requests
 */
package com.insomnia.GUI;
import com.insomnia.parser.*;
import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

public class RequestPanel extends JPanel {
    private VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    private String[] ss = {"Form","Multipart Form Data","JSON","Binary Data"};
    private JComboBox Json_FormData = new JComboBox(ss);
    private JPanel body_pane = new JPanel(){
        @Override
        public Dimension getPreferredSize(){
            return body.getSize();
        }
    };
    private JPanel body = new JPanel();
    private JPanel auth = new JPanel();
    private JPanel query = new JPanel();
    private JPanel mainCenterHeader = new JPanel(vfLayout);
    private JScrollPane scrollPane_Header_Request = new JScrollPane(mainCenterHeader);
    private HashMap<String , String> headers_values= new HashMap<>();
    private JPanel docs = new JPanel();
    private JTabbedPane tabbedPaneCenterRequest = new JTabbedPane();

    private String s []={"Get","Post","Put","Delete"};
    private JComboBox centerMenu = new JComboBox(s);
    private JTextField URLTextField = new JTextField("http://api.myproduct.com/v1/users");
    private JButton sendButton = new JButton("send");
    private JPanel centerUp = new JPanel(new BorderLayout());

    private InsomniaGUI main_class;

    public RequestPanel(InsomniaGUI m){
        main_class = m;
    }

    public JTabbedPane tabbedPaneCenterRequest() throws IOException {


        body.setBackground(Color.GRAY);
        body.add(Json_FormData,BorderLayout.NORTH);
        body.add(body_pane);
        Json_FormData.setSelectedIndex(0);
        initBody();
        Json_FormData.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                initBody();
            }
        });
        auth.setBackground(Color.GRAY);
        query.setBackground(Color.GRAY);
        mainCenterHeader.setBackground(Color.GRAY);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        docs.setBackground(Color.GRAY);
        //request-center
        tabbedPaneCenterRequest.setBackground(Color.GRAY);
        tabbedPaneCenterRequest.add("Body" , body);
        tabbedPaneCenterRequest.add("Auth" , auth);
        tabbedPaneCenterRequest.add("Query" , query);
        tabbedPaneCenterRequest.add("Header" , scrollPane_Header_Request);
        tabbedPaneCenterRequest.add("Docs" , docs);


        addHeader();

        mainCenterHeader.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (mainCenterHeader.getComponentCount()==0) addHeader();
            }
        });

        body_pane.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (((JPanel) body_pane.getComponent(0)).getComponentCount()==0 && body_insert!=null && selectedItem==0) body_insert.mouseClicked(null);
            }
        });


        return tabbedPaneCenterRequest;
    }

    /**
     *this method is for adding headers
     */
    private void addHeader(String... args){
        try {
            Border border = BorderFactory.createLineBorder(Color.BLACK, 3);
            BufferedImage master;
            master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
            Image scaled = master.getScaledInstance(20, 20, java.awt.Image.SCALE_SMOOTH);

            JTextField newHeaderField = new JTextField("header");
            newHeaderField.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    if (e!=null && !isLastComponent(((Component) e.getSource()).getParent().getParent())) return;
                    addHeader();
                }
            });
            newHeaderField.setBorder(border);
            JTextField newValueField = new JTextField("value");
            newValueField.setBorder(border);

            if (args.length>0){
                newHeaderField.setText(args[0]);
                newValueField.setText(args[1]);
            }

            JCheckBox newCheckBox = new JCheckBox();
            newCheckBox.setSelected(true);
            JButton newDelete = new JButton();
            newDelete.setPreferredSize(new Dimension(20, 20));
            newDelete.setIcon(new ImageIcon(scaled));
            newDelete.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    JButton Btn = (JButton) e.getSource();
                    //to repair showing
                    mainCenterHeader.remove(((JPanel) Btn.getParent()).getParent());
                    mainCenterHeader.revalidate();
                    mainCenterHeader.repaint();
                }
            });
            JPanel newRightOfHeader = new JPanel();
            newRightOfHeader.add(newCheckBox);
            newRightOfHeader.add(newDelete);
            JPanel new_center_header = new JPanel(new GridLayout(1, 2));
            new_center_header.add(newHeaderField);
            new_center_header.add(newValueField);
            JPanel newHeader = new JPanel(new BorderLayout());
            newHeader.add(newRightOfHeader, BorderLayout.EAST);
            newHeader.add(new_center_header, BorderLayout.CENTER);
            mainCenterHeader.add(newHeader);
            mainCenterHeader.validate();
        }catch (IOException e){
            e.printStackTrace();
        }
    }


    /**
     *
     * @param c is component
     * @return the component is the last one or not
     */
    boolean isLastComponent(Component c){
        return isLastComponent(c,mainCenterHeader);
    }

    /**
     *
     * @param c is component
     * @param p is a panel
     * @return the component is the last one or not
     */
    boolean isLastComponent(Component c,JPanel p){
        return p.getComponent(p.getComponentCount()-1)==c;
    }

    /**
     *
     * @return the headers
     */
    public HashMap<String,String> getHeaders(){
        HashMap<String,String> headers = new HashMap<>();
        for(Component c : mainCenterHeader.getComponents()){
            if (c instanceof JPanel){
                JPanel nh = (JPanel) c;
                JPanel r = (JPanel)nh.getComponent(0), l = (JPanel) nh.getComponent(1);
                JCheckBox cb = (JCheckBox) r.getComponent(0);
                if (cb.isSelected()){
                    JTextField h = (JTextField) l.getComponent(0);
                    JTextField v = (JTextField) l.getComponent(1);
                    if (!h.getText().trim().isEmpty()){
                        headers.put(h.getText().trim(),v.getText());
                    }
                }
            }
        }
        return headers;
    }

    public void addContentType(String type){
        for(Component c : mainCenterHeader.getComponents()){
            if (c instanceof JPanel){
                JPanel nh = (JPanel) c;
                JPanel l = (JPanel) nh.getComponent(1);
                    JTextField h = (JTextField) l.getComponent(0);
                    JTextField v = (JTextField) l.getComponent(1);
                    if (h.getText().toLowerCase().trim().equals("content-type")){
                      v.setText(type);
                      return;
                }
            }
        }
        addHeader("Content-Type",type);
    }

    public HashMap<String,String> getFormDataBody(){
        HashMap<String,String> bodydata = new HashMap<>();
        for(Component c : ((JPanel)body_pane.getComponent(0)).getComponents()){
            if (c instanceof JPanel){
                JPanel nh = (JPanel) c;
                JPanel l = (JPanel) nh.getComponent(1);
                    JTextField h = (JTextField) l.getComponent(0);
                    JTextField v = (JTextField) l.getComponent(1);
                    if (!h.getText().trim().isEmpty()){
                        bodydata.put(h.getText().trim(),v.getText());
                    }
            }
        }
        return bodydata;
    }

    public String getFormDataBodyAsString(){
        HashMap<String,String> b = getFormDataBody();
        if(b.size()==0) return "";
        String f = "";
        for (String key : b.keySet()){
            if (key=="-file") continue;
            f = f+key+"="+b.get(key)+"&";
        }
        return f.substring(0,f.length()-1);
    }

    public String findUploadPath(){
        HashMap<String,String> b = getFormDataBody();
        if(b.size()==0) return "";
        String f = "";
        for (String key : b.keySet()){
            if (key=="-file") f = b.get(key);
        }
        return f;
    }

    public String getHeadersAsString(HashMap<String,String> b){
        if(b.size()==0) return "";
        String f = "";
        for (String key : b.keySet()){
            f = f+key+":"+b.get(key)+";";
        }
        return f.substring(0,f.length()-1);
    }

    int selectedItem = -2;
    MouseAdapter body_insert = null;

    /**
     *create the body layout
     */
    void initBody(String... args){
        if (args.length==0 && selectedItem == Json_FormData.getSelectedIndex()) return;
        selectedItem = Json_FormData.getSelectedIndex();

        if(body_pane.getComponentCount()>0) {
            Component[] components = body_pane.getComponents();
            for(Component c : components) body_pane.remove(c);
        }

        Border border = BorderFactory.createLineBorder(Color.BLACK,3);
        if(Json_FormData.getSelectedItem().equals("JSON")) {
            JTextArea textArea = new JTextArea(){
                @Override
                public Dimension getPreferredSize(){
                    return body_pane.getSize();
                }
            };
            textArea.setToolTipText("Enter JSON");
            textArea.setBorder(border);
            if (args.length>0) textArea.setText(args[0]);
            body_pane.add(textArea);
            addContentType("application/json");
        } else if(Json_FormData.getSelectedItem().equals("Binary Data")){
            JTextField path = new JTextField("File Path"){
                @Override
                public Dimension getPreferredSize(){
                    return new Dimension(body_pane.getSize().width-16,28);
                }
            };
            if (args.length>0) path.setText(args[0]);
            path.setBorder(border);
            body_pane.add(path,BorderLayout.NORTH);

            JButton selector = new JButton("Choose File");
            body_pane.add(selector,BorderLayout.NORTH);
            selector.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    super.mouseClicked(e);
                    FileDialog fc = new FileDialog((Frame) null,"Select a file to upload");
                    fc.setMode(FileDialog.LOAD);
                    fc.setVisible(true);
                    String f = fc.getFile();
                    if (f!=null && !f.isEmpty()) {
                        path.setText(new File(fc.getDirectory(),new File(f).getName()).getAbsolutePath());
                    }
                }
            });
            addContentType("application/octet-stream");
        }else {

            final JPanel vl = new JPanel(vfLayout) {
                @Override
                public Dimension getPreferredSize() {
                    return body_pane.getSize();
                }
            };
            body_pane.add(vl);

            if (body_insert==null){

            body_insert = new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    if (e != null && !isLastComponent(((Component) e.getSource()).getParent().getParent(), vl)) return;
                    addBody();
                }
            };
        }
           if (args.length==0) body_insert.mouseClicked(null);

            if (Json_FormData.getSelectedItem().equals("Multipart Form Data")){
                addContentType("multipart/form-data");
            }else{
                addContentType("application/x-www-form-urlencoded");
            }
        }

        body_pane.revalidate();
        body_pane.repaint();


    }

    /**
     *add component to the body
     */
    private void addBody(String... args){
        Border border = BorderFactory.createLineBorder(Color.BLACK,3);
        BufferedImage master = null;
        try {
            master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
        } catch (IOException e) {
        }
        final Image scaled = master.getScaledInstance(20, 20, java.awt.Image.SCALE_SMOOTH);

        JTextField newHeaderField = new JTextField("key");
        newHeaderField.addMouseListener(body_insert);
        newHeaderField.setBorder(border);
        JTextField newValueField = new JTextField("value");
        newValueField.setBorder(border);

        if (args.length>0){
            newHeaderField.setText(args[0]);
            newValueField.setText(args[1]);
        }

        JButton newDelete = new JButton();
        newDelete.setPreferredSize(new Dimension(20, 20));
        newDelete.setIcon(new ImageIcon(scaled));

        final  JPanel vl = (JPanel) body_pane.getComponent(0);
        newDelete.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                JButton Btn = (JButton) e.getSource();
                //to repair showing
                vl.remove(((JPanel) Btn.getParent()).getParent());
                vl.revalidate();
                vl.repaint();
            }
        });
        JPanel newRightOfHeader = new JPanel();

        newRightOfHeader.add(newDelete);
        JPanel new_center_header = new JPanel(new GridLayout(1, 2));
        new_center_header.add(newHeaderField);
        new_center_header.add(newValueField);
        JPanel newHeader = new JPanel(new BorderLayout());
        newHeader.add(newRightOfHeader, BorderLayout.EAST);
        newHeader.add(new_center_header, BorderLayout.CENTER);
        vl.add(newHeader);
        vl.validate();
    }

    //request_up
    public JPanel centerUp(){
        sendButton.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                ArrayList<String> argsList = new ArrayList<>();
                argsList.add("--url");
                argsList.add(URLTextField.getText());
                argsList.add("--Method");
                argsList.add(Parser.findMethod((String)centerMenu.getSelectedItem()));

                //set if it is Json or not
                if(Json_FormData.getSelectedItem().equals("JSON")) {
                    argsList.add("--json");
                    argsList.add("--data");
                    JTextArea textArea = (JTextArea) body_pane.getComponent(0);
                    argsList.add(textArea.getText().trim());
                }
                else if(Json_FormData.getSelectedItem().equals("Binary Data")){

                    JTextField p = (JTextField) body_pane.getComponent(0);
                    if (!p.getText().isEmpty() && !p.getText().equals("File Path")) {
                        argsList.add("--upload");
                        argsList.add(p.getText());
                    }
                }else {
                    argsList.add("--data");
                    argsList.add(getFormDataBodyAsString());

                    String upload = findUploadPath();
                    if (!upload.isEmpty() && !upload.equals("File Path")) {
                        argsList.add("--upload");
                        argsList.add(upload);
                    }
                }

                HashMap<String,String> map = getHeaders();
                if (Json_FormData.getSelectedItem().equals("Multipart Form Data")){
                    map.put("Content-Type","multipart/form-data");
                }
                if (map!=null && map.size()>0){
                    argsList.add("--headers");
                    argsList.add(getHeadersAsString(map));
                }

                argsList.add("-f");
                String[] args = argsList.toArray(new String[argsList.size()]);
                ResponseData data = RequestLoader.run(Parser.parse(args));
                main_class.load(data);
            }
        });


        centerMenu.setFont(new Font("Arial",20,15 ));
        centerUp.add(centerMenu , BorderLayout.WEST);
        centerUp.add(URLTextField , BorderLayout.CENTER);
        centerUp.add(sendButton , BorderLayout.EAST);
        return centerUp;
    }


    public void load (RequestData r){
        switch (r.getMethod()){
            case "PUT":
                centerMenu.setSelectedIndex(2);
                break;
            case "POST":
                centerMenu.setSelectedIndex(1);
                break;
            case "DELETE":
                centerMenu.setSelectedIndex(3);
                break;

            default:
                centerMenu.setSelectedIndex(0);
                break;
        }

        URLTextField.setText(r.getUrl());

        if (r.isJson()){
            Json_FormData.setSelectedIndex(2);
            initBody(r.getBody());
        }else if(r.getUploadPath().length()>1){
            Json_FormData.setSelectedIndex(3);
            initBody(r.getUploadPath());
        }else{
            Json_FormData.setSelectedIndex(r.isMultipartFormData()?1:0);
            initBody("r");
            if (body_insert!=null &&!r.getBody().isEmpty()) {
                if (!r.getBody().contains("&")) {
                    String[] f1 = r.getBody().split("=");
                    addBody(f1);
                } else {
                    String[] mFields = r.getBody().split("&");
                    for (String f : mFields) {
                        String[] f0 = f.split("=");
                        addBody(f0);
                    }
                }
            }
        }

        if (r.getHeaders()!=null && r.getHeaders().size()>0){
            for (String key : r.getHeaders().keySet()){
                addHeader(key,r.getHeaders().get(key));
            }
        }
    }

    public void createRequestPanel() throws IOException {
        addToMainRequestPanel(centerUp() , tabbedPaneCenterRequest());
    }

    public void addToMainRequestPanel(JPanel centerUp ,JTabbedPane tabbedPaneCenterRequest ){
        this.setLayout(new BorderLayout());
        this.add(centerUp,BorderLayout.NORTH);
        this.add(tabbedPaneCenterRequest , BorderLayout.CENTER);
    }


    /**
     *
     * @return body panel
     */
    public JPanel getBody() {
        return body;
    }


    public JPanel getMainCenterHeader() {
        return mainCenterHeader;
    }

    public JScrollPane getScrollPane_Header_Request() {
        return scrollPane_Header_Request;
    }

    public JPanel getDocs() {
        return docs;
    }

    public JTabbedPane getTabbedPaneCenterRequest() {
        return tabbedPaneCenterRequest;
    }


    public JComboBox getCenterMenu() {
        return centerMenu;
    }

    public JPanel getCenterUp() {
        return centerUp;
    }
}
