/**
 * represents a panel for responds that contains response data and components and action listeners
 * @zahra_fatehi
 * @version 0.0
 */
package com.insomnia.GUI;
import com.insomnia.parser.ResponseData;
import javax.swing.*;
import javax.swing.border.Border;
import java.awt.*;

public class RespondPanel extends JPanel {
    private Border border = BorderFactory.createLineBorder(Color.BLACK,3);
    private VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    private JPanel row = new JPanel();
    private JTextArea massageBody = new JTextArea() {
        @Override
        public Dimension getPreferredSize() {
            return row.getSize();
        }
    };
    private JPanel mainCenterHeader_respond = new JPanel(vfLayout) ;
    private JScrollPane scrollPane_Header_Respond = new JScrollPane(mainCenterHeader_respond);
    private JPanel header_MainPanel = new JPanel(new BorderLayout());
    private JButton copyToClipBoard = new JButton("copy to clip board");
    private JPanel cookie = new JPanel();
    private JPanel timeline = new JPanel(new BorderLayout());
    private JTabbedPane tabbedPaneCenterResponse = new JTabbedPane();

    public JTabbedPane tabbedPaneCenterResponse() {
        massageBody.setLineWrap(true);
        massageBody.setBorder(border);
        row.add(massageBody);
        row.setBackground(Color.GRAY);
        scrollPane_Header_Respond.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        scrollPane_Header_Respond.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        mainCenterHeader_respond.setBackground(Color.GRAY);
        header_MainPanel.setBackground(Color.GRAY);
        header_MainPanel.add(scrollPane_Header_Respond, BorderLayout.CENTER);
        header_MainPanel.add(copyToClipBoard, BorderLayout.SOUTH);
        cookie.setBackground(Color.GRAY);
        timeline.setBackground(Color.GRAY);
        tabbedPaneCenterResponse.setBackground(Color.GRAY);
        tabbedPaneCenterResponse.add("Row", row);
        tabbedPaneCenterResponse.add("Header", header_MainPanel);
        tabbedPaneCenterResponse.add("Cookie", cookie);
        tabbedPaneCenterResponse.add("Timeline", timeline);


        return tabbedPaneCenterResponse;
    }

    JPanel up_response = new JPanel();
    public JPanel up_response() {
        JLabel label1 = new JLabel("ok");
        label1.setBorder(border);
        JLabel label2 = new JLabel("s");
        label2.setBorder(border);
        JLabel label3 = new JLabel("KB");
        label3.setBorder(border);

        up_response.add(label1);
        up_response.add(label2);
        up_response.add(label3);
        return up_response;
    }
    public void createRespondPanel(){
        addToMainRespondPanel(tabbedPaneCenterResponse() , up_response());
    }
    public void addToMainRespondPanel(JTabbedPane tabbedPaneCenterResponse, JPanel up_response){
        this.setLayout(new BorderLayout());
        this.add(tabbedPaneCenterResponse , BorderLayout.CENTER);
        this.add(up_response,BorderLayout.NORTH);
    }



    public JTextArea getMassageBody() {
        return massageBody;
    }

    public JPanel getMainCenterHeader_respond() {
        return mainCenterHeader_respond;
    }


    public JScrollPane getScrollPane_Header_Respond() {
        return scrollPane_Header_Respond;
    }

    public JPanel getHeader_MainPanel() {
        return header_MainPanel;
    }

    public JButton getCopyToClipBoard() {
        return copyToClipBoard;
    }

    public JPanel getCookie() {
        return cookie;
    }

    public JPanel getTimeline() {
        return timeline;
    }

    public JTabbedPane getTabbedPaneCenterResponse() {
        return tabbedPaneCenterResponse;
    }


    public JPanel getRow() {
        return row;
    }


    public void load(ResponseData data){
        if (data.getResponseHeaders()!=null &&data.getResponseHeaders().size()>0){
            for (String k : data.getResponseHeaders().keySet()){
                JTextField newHeaderField = new JTextField(k);
                newHeaderField.setEditable(false);
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField(data.getResponseHeaders().get(k).toString());
                newValueField.setEditable(false);
                newValueField.setBorder(border);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout()) {
                    @Override
                    public Dimension getPreferredSize(){
                        return new Dimension(header_MainPanel.getSize().width,28);
                    }
                };
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader_respond.add(newHeader);
            }
        }

        if (data.isSuccessful()) {
            massageBody.setText(data.getResponseString());
        }else{
            massageBody.setText("Error : "+(data.hasSyntaxError()?data.getSyntaxErrorLog():data.getErrorMessage()));
        }

        JLabel label1 = (JLabel) up_response.getComponent(0);
        JLabel label2 = (JLabel) up_response.getComponent(1);
        JLabel label3 = (JLabel) up_response.getComponent(2);

        label2.setText(((data.getFinalTime()-data.getStartTime())/1000)+"s");
        if (data.hasSyntaxError()){
            label1.setText("Syntax Error");
        }else {
            String isOk = data.isSuccessful() ? "OK" : "Error";
            label1.setText(data.getResponseStatus()+" "+isOk);
        }
        if (data.getSize()>1024){
            label3.setText((Math.round(data.getSize()/1024*100.0)/100.0)+" KB");
        }else {
            label3.setText(data.getSize() + " Bytes");
        }
    }
}
