package com.insomnia.parser;

public class Insomnia {
    public static void main(String [] args)  {

        for (String arg : args){
            if (arg.replace("-","").trim().toLowerCase().equals("help")){

                System.out.println("Insomnia Commands : ");
                System.out.println("-url : enter url");
                System.out.println("--Method : set request method (GET,POST,PUT,DELETE)");
                return;
            }
        }

        ResponseData data = RequestLoader.run(Parser.parse(args));

        if (data.hasSyntaxError()){
            System.out.println("Syntax Error : "+data.getSyntaxErrorLog());
        }else{
            System.out.println("Connection time : "+((data.getFinalTime()-data.getStartTime())/1000)+"s");
            System.out.println("Response Status : "+ data.getResponseStatus());

            if (data.isSuccessful()){
                System.out.println("Response : "+data.getResponseString());

                if (data.getRequestData().isShowResponseHeaders()&& data.getResponseHeaders()!=null){
                    System.out.println("******* Response Headers *******");
                    for (String key : data.getResponseHeaders().keySet()){
                        System.out.println(key+" : "+data.getResponseHeaders().get(key).toString());
                    }
                }
            }else {
                System.out.println("Error : "+data.getErrorMessage());
            }
        }
    }
}
